#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
ll N=1e6;
int main()
{
    int n,k,x;
    scanf("%d%d%d", &n, &k, &x);

        bool u=false;
        for(int i=1;i<=k/2;i++)
        {
            if(k%i==0)
            {
                if(i<=x && k/i<=x)
                {
                    u=true;
                    for(int j=1;j<=i;j++)
                    {
                        printf("%d ", N-j+1);
                    }
                    int t=n-i-k/i;
                    for(int j=1;j<=t;j++)
                    {
                        printf("%d ", N-x-j);
                    }
                    for(int j=1;j<=k/i;j++)
                    {
                        printf("%d ", N-x-j);
                    }
                    break;

                }
            }
        }
        if(!u)cout<<"-1"<<endl;

}